## mingw-w64-precice-3.2.0-4.src.tar.zst

=== thirdparty/libbacktrace/CMakeLists.txt ===
# Build the library if that hasn't happened yet

if(PRECICE_LIBBACKTRACE_PREPARED)
  message(STATUS "libbacktrace already build")
else()
  message(STATUS "Preparing libbacktrace")

  message(STATUS "Extracting sources")
  execute_process(
      COMMAND tar -xzf ${CMAKE_CURRENT_SOURCE_DIR}/libbacktrace.tar.gz
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      )

  set(_libbacktrace_sources ${CMAKE_CURRENT_BINARY_DIR}/libbacktrace-master)

  set(_step autoconf)
  message(STATUS "Running ${_step}")
  execute_process(
    COMMAND ${_step}
    WORKING_DIRECTORY ${_libbacktrace_sources}
    RESULTS_VARIABLE _r
    )
  message(STATUS "Step finished with ${_r}")

  message(STATUS "Running ./configure")
  execute_process(
    COMMAND ./configure --enable-shared=yes
    WORKING_DIRECTORY ${_libbacktrace_sources}
    RESULTS_VARIABLE _r
    )
  message(STATUS "Step finished with ${_r}")

  set(_step make)
  message(STATUS "Running ${_step}")
  execute_process(
    COMMAND ${_step}
    WORKING_DIRECTORY ${_libbacktrace_sources}
    RESULTS_VARIABLE _r
    )
  message(STATUS "Step finished with ${_r}")
  unset(_r)
  unset(step)

  message(STATUS "Copying files")
  file(COPY
    ${_libbacktrace_sources}/backtrace.h
    ${_libbacktrace_sources}/.libs/libbacktrace.so
    ${_libbacktrace_sources}/.libs/libbacktrace.so.0
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
    FOLLOW_SYMLINK_CHAIN)

  unset(_libbacktrace_sources)

  message(STATUS "libbacktrace built successfully")
  set(PRECICE_LIBBACKTRACE_PREPARED YES CACHE BOOL "Has the libbacktrace been build successfully?" FORCE)
  mark_as_advanced(PRECICE_LIBBACKTRACE_PREPARED)
endif()

# Create the library target
add_library(internal::libbacktrace SHARED IMPORTED GLOBAL)
set_target_properties(internal::libbacktrace PROPERTIES IMPORTED_LOCATION ${CMAKE_CURRENT_BINARY_DIR}/libbacktrace.so)
target_include_directories(internal::libbacktrace INTERFACE ${CMAKE_CURRENT_BINARY_DIR})

=== examples/solverdummies/cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)
project(SolverdummyCPP LANGUAGES CXX DESCRIPTION "preCICE CPP solver dummy")

find_package(precice REQUIRED CONFIG)

add_executable(solverdummy solverdummy.cpp)
set_target_properties(solverdummy PROPERTIES CXX_STANDARD 11)
target_link_libraries(solverdummy PRIVATE precice::precice)


enable_testing()
add_test(NAME precice.solverdummy
  COMMAND ${CMAKE_COMMAND}
  -DDUMMY_EXE=$<TARGET_FILE:solverdummy>
  -DDUMMY_CONFIG=${CMAKE_CURRENT_SOURCE_DIR}/../precice-config.xml
  -V
  -P ${CMAKE_CURRENT_SOURCE_DIR}/test.cmake
  )

=== tools/releasing/packaging/debian/changelog ===
libprecice1 (1.6.1) experimental; urgency=low

  * New upstream release 1.6.1

 -- the preCICE developers <precice@mailman.informatik.uni-stuttgart.de>  Fri, 13 Sep 2019 11:07:42 +0200

libprecice1 (1.6.0) experimental; urgency=low

  * New upstream release 1.6.0

 -- the preCICE developers <precice@mailman.informatik.uni-stuttgart.de>  Wed, 11 Sep 2019 19:58:06 +0200

libprecice1 (1.1.1) experimental; urgency=low

  * Fix SConstruct symlink build target failing when using lowercase build (debug, release) names.

 -- the preCICE developers <precice@mailman.informatik.uni-stuttgart.de>  Thu, 19 Apr 2018 16:37:34 +0200

libprecice2 (2.0.0) experimental; urgency=low

  * New upstream release 2.0.0

 -- the preCICE developers <info@precice.org>  Mon, 03 Feb 2020 13:14:16 +0100

libprecice2 (2.0.1) experimental; urgency=low

  * New upstream release 2.0.1

 -- the preCICE developers <info@precice.org>  Tue, 25 Feb 2020 11:53:39 +0100

libprecice2 (2.0.2) experimental; urgency=low

  * New upstream release 2.0.2

 -- the preCICE developers <info@precice.org>  Wed, 01 Apr 2020 11:47:04 +0200

libprecice2 (2.1.0) experimental; urgency=low

  * New upstream release 2.1.0

 -- the preCICE developers <info@precice.org>  Tue, 21 Jul 2020 09:12:08 +0200

libprecice2 (2.1.1) experimental; urgency=low

  * New upstream release 2.1.1

 -- the preCICE developers <info@precice.org>  Tue, 06 Oct 2020 11:43:48 +0200

libprecice2 (2.2.0) experimental; urgency=low

  * New upstream release 2.2.0

 -- the preCICE developers <info@precice.org>  Mon, 18 Jan 2021 21:44:05 +0100

libprecice2 (2.2.1) experimental; urgency=low

  * New upstream release 2.2.1

 -- the preCICE developers <info@precice.org>  Tue, 18 May 2021 09:37:04 +0200

libprecice2 (2.3.0) experimental; urgency=low

  * New upstream release 2.3.0

 -- the preCICE developers <info@precice.org>  Wed, 15 Sep 2021 16:37:46 +0200

libprecice2 (2.4.0) experimental; urgency=low

  * New upstream release 2.4.0

 -- the preCICE developers <info@precice.org>  Mon, 09 May 2022 13:20:21 +0200

libprecice2 (2.5.0) experimental; urgency=low

  * New upstream release 2.5.0

 -- the preCICE developers <info@precice.org>  Thu, 04 Aug 2022 08:57:12 +0200

libprecice3 (3.0.0) experimental; urgency=low

  * New upstream release 3.0.0

 -- the preCICE developers <info@precice.org>  Wed, 10 Jan 2024 16:26:20 +0100

libprecice3 (3.1.0) experimental; urgency=low

  * New upstream release 3.1.0

 -- the preCICE developers <info@precice.org>  Thu, 28 Mar 2024 16:43:05 +0100

libprecice3 (3.1.1) experimental; urgency=low

  * New upstream release 3.1.1

 -- the preCICE developers <info@precice.org>  Fri, 12 Apr 2024 11:40:47 +0200

libprecice3 (3.1.2) experimental; urgency=low

  * New upstream release 3.1.2

 -- the preCICE developers <info@precice.org>  Fri, 15 May 2024 16:33:00 +0200

libprecice3 (3.2.0) experimental; urgency=low

  * New upstream release 3.2.0

 -- the preCICE developers <info@precice.org>  Tue, 25 Mar 2025 16:43:38 +0100

=== PKGBUILD ===
# Maintainer: Rafal Brzegowy <rafal.brzegowy@yahoo.com>
# Contributor: Raed Rizqie <raed.rizqie@gmail.com>

_realname=precice
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=3.2.0
pkgrel=4
pkgdesc='A Coupling Library for Partitioned Multi-Physics Simulations on Massively Parallel Systems (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.precice.org'
msys2_repository_url='https://github.com/precice/precice'
license=('spdx:LGPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-boost-libs"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         #"${MINGW_PACKAGE_PREFIX}-petsc"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-python-numpy")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             $([[ ${CARCH} == aarch64 ]] || echo "${MINGW_PACKAGE_PREFIX}-msmpi")
             #"${MINGW_PACKAGE_PREFIX}-ninja"
             #"${MINGW_PACKAGE_PREFIX}-petsc-build"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "git")
source=(https://github.com/precice/precice/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz
        001-fix-libprecice-dll-installation.patch
        002-fix-export-defs.patch::https://github.com/precice/precice/commit/f7a4723827bbf20062fe004322b837f348374af3.patch
        003-add-win32-deps.patch::https://github.com/precice/precice/commit/2d08cf23abe81490f11c2be0e00afd43648ee504.patch
        004-fix-build-with-libxml2-2.14.patch::https://github.com/precice/precice/commit/d54c0e6d9e62ce314a91f05f51635472f0758b07.patch)
sha256sums=('93523f1a56e0cfd338d8e190baa06129ee811acdb1c697468a3c85c516d63464'
            '49fe04f9e72d1034b8909a7b593ccf42eeaf5203d9188f71706260948a0fb566'
            '8efe809bf94f93d2fa0bcdf6cc95cda4028a469b5bd88c5a1a7b0738e615e05a'
            '786d2f0be4e6131192501bf81d574ca5b3839e6de95a78de3ceea0738c7fa81a'
            '37215fbc9a43a2628edfba4db4c52554766f1ab5bbfc1f7324050a3ebe26a9ae')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Np1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd ${_realname}-${pkgver}
  apply_patch_with_msg \
    001-fix-libprecice-dll-installation.patch \
    002-fix-export-defs.patch \
    003-add-win32-deps.patch \
    004-fix-build-with-libxml2-2.14.patch
}

build() {
  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  # . ${MINGW_PREFIX}/src/petsc/petsc
  # for build in ${petsc_builds}; do
  #   #export PETSC_ARCH=${build}
  #   export PETSC_ARCH=dmo
  #   export PETSC_DIR=${MINGW_PREFIX}/src/petsc
  # done

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CARCH} == aarch64 ]]; then
    extra_config+=("-DPRECICE_FEATURE_MPI_COMMUNICATION=OFF")
  else
    extra_config+=("-DPRECICE_FEATURE_MPI_COMMUNICATION=ON")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    CXXFLAGS+=" -Wno-c++11-narrowing"
  else
    CXXFLAGS+=" -Wno-narrowing"
  fi

  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake \
      -G"Ninja" \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DBUILD_SHARED_LIBS=ON \
      -DBUILD_TESTING=OFF \
      ${extra_config[@]} \
      -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
      -DPRECICE_FEATURE_PETSC_MAPPING=OFF \
      -DPRECICE_FEATURE_PYTHON_ACTIONS=ON \
      -DPRECICE_BUILD_TOOLS=ON \
      -Wno-dev \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
